For the complete documentation index, see llms.txt. This page is also available as Markdown.

Steps

Get Run Steps

get

Get all steps for a given pipeline run.

Args: run_id: ID of the pipeline run. step_run_filter_model: Filter model used for pagination, sorting, filtering

Returns: The steps for a given pipeline run.

Authorizations
OAuth2passwordRequired
Token URL:
Path parameters
run_idstring · uuidRequired
Query parameters
sort_bystringOptionalDefault: created
logical_operatorstring · enumOptional

Logical Ops to use to combine filters on list methods.

Default: andPossible values:
pageinteger · min: 1OptionalDefault: 1
sizeinteger · min: 1 · max: 10000OptionalDefault: 20
idany of · nullableOptional
string · uuidOptional
or
stringOptional
or
createdany of · nullableOptional
string · date-timeOptional
or
stringOptional
or
updatedany of · nullableOptional
string · date-timeOptional
or
stringOptional
or
run_metadataany of · nullableOptional
stringOptional
or
string[]Optional
scope_userstring · uuid · nullableOptional
userany of · nullableOptional
string · uuidOptional
or
stringOptional
or
projectany of · nullableOptional
string · uuidOptional
or
stringOptional
nameany of · nullableOptional
stringOptional
or
string[]Optional
code_hashany of · nullableOptional
stringOptional
or
string[]Optional
cache_keyany of · nullableOptional
stringOptional
or
string[]Optional
statusany of · nullableOptional
stringOptional
or
string[]Optional
start_timeany of · nullableOptional
string · date-timeOptional
or
stringOptional
or
end_timeany of · nullableOptional
string · date-timeOptional
or
stringOptional
or
pipeline_run_idany of · nullableOptional
string · uuidOptional
or
stringOptional
or
snapshot_idany of · nullableOptional
string · uuidOptional
or
stringOptional
or
original_step_run_idany of · nullableOptional
string · uuidOptional
or
stringOptional
or
model_version_idany of · nullableOptional
string · uuidOptional
or
stringOptional
or
modelany of · nullableOptional
string · uuidOptional
or
stringOptional
or
versionany of · nullableOptional
integerOptional
or
stringOptional
or
exclude_retriedboolean · nullableOptional
cache_expires_atany of · nullableOptional
string · date-timeOptional
or
stringOptional
or
cache_expiredboolean · nullableOptional
Responses
200

Successful Response

application/json
indexintegerRequired
max_sizeintegerRequired
total_pagesintegerRequired
totalintegerRequired
get/api/v1/runs/{run_id}/steps
GET /api/v1/runs/{run_id}/steps HTTP/1.1
Authorization: Bearer YOUR_OAUTH2_TOKEN
Accept: */*
{
  "index": 1,
  "max_size": 1,
  "total_pages": 1,
  "total": 1,
  "items": [
    {
      "body": {
        "created": "2026-01-01T00:00:00.000Z",
        "updated": "2026-01-01T00:00:00.000Z",
        "user_id": "123e4567-e89b-12d3-a456-426614174000",
        "project_id": "123e4567-e89b-12d3-a456-426614174000",
        "type": "tool_call",
        "status": "initializing",
        "version": 1,
        "is_retriable": true,
        "start_time": "2026-01-01T00:00:00.000Z",
        "end_time": "2026-01-01T00:00:00.000Z",
        "latest_heartbeat": "2026-01-01T00:00:00.000Z",
        "model_version_id": "123e4567-e89b-12d3-a456-426614174000",
        "substitutions": {
          "ANY_ADDITIONAL_PROPERTY": "text"
        },
        "heartbeat_threshold": 1
      },
      "metadata": {
        "config": {
          "enable_cache": true,
          "enable_artifact_metadata": true,
          "enable_artifact_visualization": true,
          "enable_step_logs": true,
          "step_operator": true,
          "experiment_tracker": true,
          "parameters": {
            "ANY_ADDITIONAL_PROPERTY": "anything"
          },
          "settings": {
            "ANY_ADDITIONAL_PROPERTY": {
              "ANY_ADDITIONAL_PROPERTY": "anything"
            }
          },
          "environment": {
            "ANY_ADDITIONAL_PROPERTY": "text"
          },
          "secrets": [
            "123e4567-e89b-12d3-a456-426614174000"
          ],
          "extra": {
            "ANY_ADDITIONAL_PROPERTY": "anything"
          },
          "failure_hook_source": null,
          "success_hook_source": null,
          "start_hook_source": null,
          "end_hook_source": null,
          "model": {
            "name": "text",
            "license": "text",
            "description": "text",
            "audience": "text",
            "use_cases": "text",
            "limitations": "text",
            "trade_offs": "text",
            "ethics": "text",
            "tags": [
              "text"
            ],
            "version": "none",
            "save_models_to_registry": true,
            "model_version_id": "123e4567-e89b-12d3-a456-426614174000",
            "suppress_class_validation_warnings": false
          },
          "retry": {
            "max_retries": 1,
            "delay": 0,
            "backoff": 0
          },
          "substitutions": {
            "ANY_ADDITIONAL_PROPERTY": "text"
          },
          "cache_policy": {
            "include_step_code": true,
            "include_step_parameters": true,
            "include_artifact_values": true,
            "include_artifact_ids": true,
            "ignored_inputs": [
              "text"
            ],
            "file_dependencies": [
              "text"
            ],
            "source_dependencies": [
              {
                "module": "text",
                "attribute": "text",
                "type": "user",
                "ANY_ADDITIONAL_PROPERTY": "anything"
              }
            ],
            "cache_func": {
              "module": "text",
              "attribute": "text",
              "type": "user",
              "ANY_ADDITIONAL_PROPERTY": "anything"
            },
            "expires_after": 1
          },
          "runtime": "inline",
          "heartbeat_healthy_threshold": 30,
          "group": {
            "id": "text",
            "name": "text",
            "type": "manual"
          },
          "outputs": {
            "ANY_ADDITIONAL_PROPERTY": {
              "materializer_source": [
                {
                  "module": "text",
                  "attribute": "text",
                  "type": "user",
                  "ANY_ADDITIONAL_PROPERTY": "anything"
                }
              ],
              "default_materializer_source": {
                "module": "text",
                "attribute": "text",
                "type": "user",
                "ANY_ADDITIONAL_PROPERTY": "anything"
              },
              "artifact_config": {
                "name": "text",
                "version": "text",
                "tags": [
                  "text"
                ],
                "run_metadata": {
                  "ANY_ADDITIONAL_PROPERTY": "text"
                },
                "artifact_type": "DataAnalysisArtifact"
              }
            }
          },
          "name": "text",
          "step_type": "tool_call",
          "template": "text",
          "caching_parameters": {
            "ANY_ADDITIONAL_PROPERTY": "anything"
          },
          "external_input_artifacts": {
            "ANY_ADDITIONAL_PROPERTY": {
              "id": "123e4567-e89b-12d3-a456-426614174000"
            }
          },
          "model_artifacts_or_metadata": {
            "ANY_ADDITIONAL_PROPERTY": {
              "model_name": "text",
              "model_version": "text",
              "artifact_name": "text",
              "artifact_version": "text",
              "metadata_name": "text"
            }
          },
          "client_lazy_loaders": {
            "ANY_ADDITIONAL_PROPERTY": {
              "method_name": "text",
              "call_chain": [
                {
                  "attribute_name": "text",
                  "is_call": false,
                  "call_args": [],
                  "call_kwargs": {
                    "ANY_ADDITIONAL_PROPERTY": "anything"
                  },
                  "selector": null
                }
              ],
              "exclude_next_call": false
            }
          },
          "command": [
            "text"
          ]
        },
        "spec": {
          "source": {
            "module": "text",
            "attribute": "text",
            "type": "user",
            "ANY_ADDITIONAL_PROPERTY": "anything"
          },
          "upstream_steps": [
            "text"
          ],
          "inputs": {
            "ANY_ADDITIONAL_PROPERTY": {
              "step_name": "text",
              "output_name": "text",
              "chunk_index": 1,
              "chunk_size": 1
            }
          },
          "invocation_id": "text",
          "enable_heartbeat": false,
          "parameter_spec": {
            "ANY_ADDITIONAL_PROPERTY": "anything"
          }
        },
        "cache_key": "text",
        "cache_expires_at": "2026-01-01T00:00:00.000Z",
        "code_hash": "text",
        "docstring": "text",
        "source_code": "text",
        "exception_info": {
          "traceback": "text",
          "source": "text",
          "message": "text",
          "user_code_line": 1,
          "ANY_ADDITIONAL_PROPERTY": "anything"
        },
        "snapshot_id": "123e4567-e89b-12d3-a456-426614174000",
        "pipeline_run_id": "123e4567-e89b-12d3-a456-426614174000",
        "original_step_run_id": "123e4567-e89b-12d3-a456-426614174000",
        "parent_step_ids": [
          "123e4567-e89b-12d3-a456-426614174000"
        ],
        "run_metadata": {
          "ANY_ADDITIONAL_PROPERTY": "text"
        }
      },
      "resources": {
        "user": {
          "body": {
            "created": "2026-01-01T00:00:00.000Z",
            "updated": "2026-01-01T00:00:00.000Z",
            "active": false,
            "activation_token": "text",
            "full_name": "",
            "email_opted_in": true,
            "is_service_account": true,
            "is_admin": true,
            "default_project_id": "123e4567-e89b-12d3-a456-426614174000",
            "avatar_url": "text"
          },
          "metadata": {
            "password_changed_at": "2026-01-01T00:00:00.000Z",
            "email": "",
            "external_user_id": "123e4567-e89b-12d3-a456-426614174000",
            "user_metadata": {
              "ANY_ADDITIONAL_PROPERTY": "anything"
            }
          },
          "resources": {
            "ANY_ADDITIONAL_PROPERTY": "anything"
          },
          "id": "123e4567-e89b-12d3-a456-426614174000",
          "permission_denied": false,
          "name": "text"
        },
        "log_collection": [
          {
            "body": {
              "created": "2026-01-01T00:00:00.000Z",
              "updated": "2026-01-01T00:00:00.000Z",
              "user_id": "123e4567-e89b-12d3-a456-426614174000",
              "project_id": "123e4567-e89b-12d3-a456-426614174000",
              "uri": "text",
              "source": "text"
            },
            "metadata": {
              "step_run_id": "123e4567-e89b-12d3-a456-426614174000",
              "pipeline_run_id": "123e4567-e89b-12d3-a456-426614174000",
              "artifact_store_id": "123e4567-e89b-12d3-a456-426614174000",
              "log_store_id": "123e4567-e89b-12d3-a456-426614174000",
              "hook_invocation_id": "123e4567-e89b-12d3-a456-426614174000"
            },
            "resources": {
              "user": {
                "body": {
                  "created": "2026-01-01T00:00:00.000Z",
                  "updated": "2026-01-01T00:00:00.000Z",
                  "active": false,
                  "activation_token": "text",
                  "full_name": "",
                  "email_opted_in": true,
                  "is_service_account": true,
                  "is_admin": true,
                  "default_project_id": "123e4567-e89b-12d3-a456-426614174000",
                  "avatar_url": "text"
                },
                "metadata": {
                  "password_changed_at": "2026-01-01T00:00:00.000Z",
                  "email": "",
                  "external_user_id": "123e4567-e89b-12d3-a456-426614174000",
                  "user_metadata": {
                    "ANY_ADDITIONAL_PROPERTY": "anything"
                  }
                },
                "resources": {
                  "ANY_ADDITIONAL_PROPERTY": "anything"
                },
                "id": "123e4567-e89b-12d3-a456-426614174000",
                "permission_denied": false,
                "name": "text"
              },
              "ANY_ADDITIONAL_PROPERTY": "anything"
            },
            "id": "123e4567-e89b-12d3-a456-426614174000",
            "permission_denied": false
          }
        ],
        "model_version": "[Circular Reference]",
        "inputs": {
          "ANY_ADDITIONAL_PROPERTY": "[Circular Reference]"
        },
        "outputs": {
          "ANY_ADDITIONAL_PROPERTY": "[Circular Reference]"
        },
        "resource_request": "[Circular Reference]",
        "ANY_ADDITIONAL_PROPERTY": "anything"
      },
      "id": "123e4567-e89b-12d3-a456-426614174000",
      "permission_denied": false,
      "name": "text"
    }
  ]
}
ZenML Scarf

Last updated

Was this helpful?